config/routes.rb
Rails.application.routes.draw do


  root to: "home#index"

  # Devise
  devise_for :users, controllers: { registrations: 'users/registrations' }
  
  # Users
  resources :users, only: [:index, :show, :edit, :update] do
    resources :follows, only: [:index, :create, :destroy]
    resources :bookmarks, only: [:index, :create, :destroy]
  end
  
  # Articles
  resources :articles do
    collection do 
      get :my
    end
    
    # Alternatives
    resources :alternatives, shallow: true do
      collection do
        post :update_all
      end
    end

    # Criteria
    resources :criteria, only: [:index]

    # Ratings
    resources :ratings, only: [:index]

    # Members
    resources :members, shallow: true do
      collection do
        get :new_request
      end
      member do
        get :approval
      end
    end
  end

  # Results
  get '/articles/:article_id/results' => 'results#index', as: :article_results
  get '/articles/:article_id/chart'   => 'results#chart', as: :article_chart

  # Visualization
  get '/articles/:article_id/viz'     => 'viz#index',    as: :article_viz
  get '/articles/:article_id/sankey'  => 'viz#sankey',   as: :article_sankey

  # Sensitivity Analysis 
  get '/articles/:article_id/sensitivity' => 'sensitivity#index',  as: :article_sensitivity
  get '/articles/:article_id/sensitivity_data' => 'sensitivity#data',  as: :article_sensitivity_data

  # Appraisal
  resources :appraisals, only: :destroy
  
  resources :criteria, only: [:show, :edit, :update, :destroy] do
    member do
      get :tree
      get 'new' => :new, as: :new
      post '' => :create, as: :create_sub
    end
    
    controller :direct_comparisons do
      get 'direct_comparisons/new'  => :new,    as: :new_direct_comparisons
      get 'direct_comparisons/edit' => :edit,   as: :edit_direct_comparisons
      post 'direct_comparisons'     => :create, as: :direct_comparisons
      patch 'direct_comparisons'    => :update
      put 'direct_comparisons'      => :update
    end

    controller :magiq_comparisons do
      get 'magiq_comparisons/new'  => :new,    as: :new_magiq_comparisons
      get 'magiq_comparisons/edit' => :edit,   as: :edit_magiq_comparisons
      post 'magiq_comparisons'     => :create, as: :magiq_comparisons
      patch 'magiq_comparisons'    => :update
      put 'magiq_comparisons'      => :update
    end

    controller :ahp_comparisons do
      get 'ahp_comparisons/new'  => :new,    as: :new_ahp_comparisons
      get 'ahp_comparisons/edit' => :edit,   as: :edit_ahp_comparisons
      post 'ahp_comparisons'     => :create, as: :ahp_comparisons
      patch 'ahp_comparisons'    => :update
      put 'ahp_comparisons'      => :update
    end

    controller :ratings do
      get 'ratings' => :show, as: :ratings
    end
  end

end

app/controllers/sensitivity_controller.rb
class SensitivityController < ApplicationController
  include TurbolinksCacheControl
  skip_before_action :authenticate_user!
  
  before_action :set_article
  before_action :set_criterion
  before_action :set_member

  def index
    authorize! :read, @article
    @criteria_presenter = CriterionPresenter.new @root, current_user, member_id: params[:member_id]
  end

  def data
    authorize! :read, @article
    value_tree = ValueTree.new @article.id, @member.id
    
    respond_to do |format|
      format.json do
        begin
          @presenter = SensitivityPresenter.new value_tree, @root.id, @criterion.id
        rescue => e
          render :json => {error: e.message, status: 400 }, :status => :bad_request
        end
      end
    end
  end

  private

  def set_article
    @article = Article.find(params[:article_id])
  end

  def set_criterion
    @root = @article.criteria.root
    @criterion = params[:criterion_id] ? 
                  Criterion.find(params[:criterion_id]) : 
                  @root.children.order(:position).first
  end

  def set_member
    @member = params[:member_id] ? Member.find(params[:member_id]) : @article.members.author.take
  end

end

app/views/sensitivity/_sidepanel.html.slim
-if p.root.blank?
  .well.side-widget
    .side-widget-header
    .side-widget-title Criteria Tree
    .side-widget-content
      .alert.alert-error
        p You have not created any criterion.
-else
  .well.side-widget
    .side-widget-header
      a.resize-button data-toggle="collapse" data-target="#widget1" href="#" 
        i.icon-minus
    .side-widget-title Criteria Tree
    #widget1.collapse.in
      .side-widget-content
        = content_tag "div", id: "sensitivity-tree", data: {node: p.root.id, allow_click: p.allow_navigate, aid: p.article_id, pid: p.member_id} do
          div style="width:90%;"
            = image_tag "ajax-loader.gif"

app/views/sensitivity/index.html.slim
- page_title "Sensitivity Analysis for #{@article.title}"

= article_menu @article
- content_for :left_frame do
  = render partial: 'sidepanel', locals:{ p: @criteria_presenter }

  .alert.alert-warning
    a.close data-dismiss="alert" ×
    = "Showing sensitivity for criterion: <strong class='wrt'>#{@criterion.title}</strong>. <br>Click one of the criteria above to view sensitivity with respect to other criteria.".html_safe

#container-box
  = render partial: 'shared/results_nav_menu', locals: { presenter: @criteria_presenter }
  = render 'shared/flash_messages'

  .widget
    .widget-header.ellipsis
      i.icon-bar-chart
      h3 Sensitivity Analysis
    .well.well-widget-content
      - if @criterion.root?
        .section
          | Select a criterion under the goal
      - else
        .section
          .widget-content-title Sensitivity with respect to
          h3.wrt = @criterion.title
          h4 
            | Current weight value: 
            span.weight-value
          .alert.alert-info
            a.close data-dismiss="alert" ×
            | Hover over the sensitivity chart below to see ranking changes with respect to changes in the weight of the selected criterion.
        .section style="padding-top: 0px; min-height:350px"
          .span6
            .widget-content-title Sensitivity Chart
            #sensitivity-chart data-cid="#{@criterion.id}" data-url="#{article_sensitivity_data_path(@article, format:'json')}"
              = image_tag "ajax-loader.gif"
          .span6
            .widget-content-title#point-info 
              | Rank at weight of:  
              span.weight-value
            #rank-chart
              = image_tag "ajax-loader.gif"
      